// Cordier Yves
// le 27/10/2018
// La classe Boitetext
// necessite la presence du fichier DefType dans le repertoire de travail
/*
	Processing étant au départ développé pour créer des applications à base graphique,
	il ne possède pas (à ma conaissance) d'objet permettant d'avoir une fenètre de type TTY
	(tlétype) dans son application. Or il est comode de pouvoir dialoguer sous forme texte avec 
	l'utilisateur de l'application.
	Cette unité implemente donc une fenètre de type texte (télétype)
	
	Attention : pour pouvoir fonctionner correctement, il est nécessaire 
	de mettre en place une police de caractère de type monotype 
	(tous les caractères ont la même largeur comme dans l'ancien tempsavec nos machine 
	à écrire et/ou imprimantes à aiguilles.)
	exemple de code à implementer dans le setup()

	...
  // Instanciation d'un objet fonte de caractère pour pouvoir charger la fonte
  PFont mono;
  // chargement de la fonte de caractere à partir du sous répertoire data du programme principal
  // il sagit d'une fonte non proportionelle indispensable au fonctionnement correct en mode TTY de la boite texte
  mono = loadFont("DejaVuSansMono-48.vlw");
  // mise en place de la fonte pour le tracé graphique des caractères
  textFont(mono);
  ...

*/
/*
 // Le créateur 
 public  Boitetext(int px, int py,int Posref, int ncar, int nlig, int tc, boolean cadr, color fondcol, color textcol, color cadrecol)
 px : position sur x du coin en haut à gauche
 py : position sur y du coin en haut à gauche
 posref: Point de reference de position 00 : haut gauche, 01 : haut droite, 11 : bas droite, 10 : bas gauche
 ncar : nb de caractères en x >0
 nlig : nb de lignes de la boites >0
 tc : taille des caractères en pixels
 cadr : on trace oui ou non un cadre à la boite
 fondcol : couleur du fond
 textcol : couleur du texte
 cadrecol : couleur du cadre si cadr==true
 // ================================================
 void setModeEnroule(boolean mode)
 mode : false : scolling vertical automatique
 true : enroulement vertical de la boite
 
 // ================================================
 void setPos(int x, int y)
 x,y position du curseur courant pour ecrire (0,0) correspond au coin en haut à gauche
 
 // ================================================
 void effaceCurseur()
 efface le trait de curseur (procedure interne)
 
 // ================================================
 void afficheCurseur()
 affiche le trait de curseur
 
 // ================================================
 void blinkCurseur()
 fait clignotter le curseur
 mettre cette procedure à la fin de la procedure draw()
 
 // ================================================
 void scrolup()
 scoll la boite verticalement d'une ligne (effet suivant le mode d'enroulement
 
 // ================================================
 void videLigne(int n)
 efface la ligne n
 
 // ================================================
 void clear()
 vide la boite
 
 // ================================================
 void graphClreoln()
 efface la fin de ligne à partir du curseur
 
 // ================================================
 void dessineBoite(boolean mode)
 mode = true : dessine la boite avec son contenu
 false : dessine la boite sans son contenu
 
 // ================================================
 void dessineToutTexte()
 ecris le contenu de la boite
 
 // ================================================
 void dessineLigne(int n)
 ecris la ligne n°n
 
 // ================================================
 void avanceCurseur()
 avance le curseur d'un cran (procedure interne)
 
 // ===============================================
 void afficheCaractere(int x, int y, char c)
 affiche un caractère à (x,y)
 
 // ===============================================
 void afficheTexteXY(int x, int y, String t)
 affiche une chaine de caractere t à la position (x,y) 
 nota : si la chaine depasse la boite, elle est tronquée
 
 // ================================================
 void graphprint(char c)
 imprime un caractère au curseur courant puis avance le curseur
 
 void graphprint(Char c)
 imprime le contenu d'un objet Char au curseur courant puis avance le curseur
 
 // ================================================
 void graphprint(String c)
 idem pour une chaine de caractere
 
 // ================================================
 void graphprintln(char c)
 imprime un caractere et passe à la ligne (gestion du curseur)
 
 void graphprintln(Char c)
 imprime le contenu d'un objet Char au curseur courant puis passe à la ligne
 
 // ================================================
 void graphprintln(String c)
 idem pour une chaine de caractere
 
 // ================================================
 void graphprint(int i)
 affiche un entier au curseur courant
 
 void graphprint(Int i)
 imprime le contenu d'un objet Int au curseur courant puis avance le curseur
 
 // ================================================
 void graphprintln(int i)
 idem et passe à la ligne
 
 void graphprint(Int i)
 imprime le contenu d'un objet Char au curseur courant puis passe à la ligne
 
 // ================================================
 void graphprint(float v)
 affiche un flotant avec 2 digits derriere la virgule au curseur courant
 
 void graphprint(Float v)
 imprime le contenu d'un objet Float au curseur courant puis avance le curseur
 
 // ================================================
 void graphprintln(float v)
 idem et passe à la ligne
 
 void graphprintln(Float v)
 idem pour un objet Float
 
 // ================================================
 void graphprint(float v,int n) 
 affiche un flotant avec n>=0 digits derriere la virgule au curseur courant
 
 void graphprint(Float v, int n)
 idem pour un ojet Float
 
 // ================================================
 void graphprintln(float v, int n)
 idem et passe à la ligne
 
 void graphprintln(Float v, int n)
 idem pour un ojet Float
 
 // ================================================
 void graphprint(boolean b)
 affiche un boolean sous la forme True ou False
 
 void graphprint(Boolean b)
 Idem pour un objet Boolean
 
 // ================================================
 void graphprintln(boolean b)
 affiche un boolean sous la forme True ou False et passe à la ligne
 
 void graphprint(Boolean b)
 Idem pour un objet Boolean
 
 // ================================================
 void graphprint(float v,int t ,int n) derriere la virgule au curseur courant
 affiche un flotant avec n>=0 digits derriere la virgule sur au total t digits au curseur courant
 
 void graphprint(Float v, int t, int n)
 idem pour un ojet Float
 
 // ================================================
 void graphprintln(float v, int t, int n)
 idem et passe à la ligne
 
 void graphprintln(Float v, int t, int n)
 idem pour un ojet Float
 
 // ================================================
 void graphprintArray(int[] d)
 imprime un tableau unidimentionnel d'entiers
 
 // ================================================
 void graphprintArray(String[] d)
 imprime un tableau unidimentionnel de chaines de caracteres
 
 */
class  Boitetext
{
  private char[] contenuTab;
  private int posx=0;
  private int posy=0;
  private int ncx =0;
  private int ncy = 0;
  private int taille = 10;
  private boolean cadre=false;
  private color colfond ;
  private color coltexte;
  private color colcadre ;
  private int cursX=0;
  private int cursY=0;
  private boolean enroule = false;
  private int index=0; // l'index du dernier caractère tracé

  private int tailleBoiteX;
  private int tailleBoiteY;

  private boolean curseur=false;
  private boolean cursOn = false;
  private int cursStoX = 0;
  private int cursStoY = 0;
  private int dernierClignottement=millis();

  // Le créateur 
  public  Boitetext(int px, int py, int posref, int ncar, int nlig, int tc, boolean cadr, color fondcol, color textcol, color cadrecol)
  { 
    posx=px; 
    posy=py; 
    ncx=ncar; 
    ncy=nlig; 
    taille=tc;
    cadre=cadr; 
    colfond=fondcol;
    coltexte=textcol;
    colcadre=cadrecol;
    cursX=0;
    cursY=0;
    if (!cadre) colcadre=colfond;
    tailleBoiteX=int(ncx*taille*0.9 +4);
    tailleBoiteY=int(taille*ncy*1.5+4);
    // correction en fonction de posref
    if ((posref % 10)>0) posx=posx-tailleBoiteX;  // reference à gauche de la boite
    if ((posref /10)>0) posy=posy-tailleBoiteY;  // reference en bas de la boite
    contenuTab=new char[ncx*ncy];
    for (int i=0; i<ncx*ncy; i++) contenuTab[i]=' '; // on rempli de blancs;
  }
  // ================================================
  void setModeEnroule(boolean mode)
  {
    enroule=mode;
  }

  // ================================================
  void setCurseur(boolean on)
  {
    if (on!=cursOn)
    {
      cursOn=on;
      if (cursOn)
      {
        curseur=true;
      } else
      {
        effaceCurseur();
        curseur=false;
      }
    }
  }

  // ================================================
  void effaceCurseur()
  {
    // on efface le trait de curseur
    stroke(colfond);
    strokeWeight(1);
    stroke(1);
    int X1=int(cursStoX*taille*0.9+2+posx);
    int X2=int(X1+taille*0.9);
    int Y= int((cursStoY+1)*taille*1.5+3+posy);
    line(X1, Y, X2, Y);
  }
  // ================================================
  void afficheCurseur()
  { 
    // on affiche
    stroke(coltexte);
    strokeWeight(1);
    int X1=int(cursX*taille*0.9+2+posx);
    int X2=int(X1+taille*0.9);
    int Y= int((cursY+1)*taille*1.5+3+posy);
    line(X1, Y, X2, Y);
    cursStoX=cursX;
    cursStoY=cursY;
  }
  // ================================================
  void blinkCurseur()
  { 
    if (cursOn)
    {
      int temps=millis();
      if (temps-dernierClignottement >200)
      { 
        dernierClignottement=temps;
        if (curseur) effaceCurseur();
        else
          afficheCurseur();
        curseur=!curseur;
      }
    }
  }
  // ================================================
  void setPos(int x, int y)
  { 
    if (curseur) effaceCurseur();

    cursX=x % ncx; 
    cursY=y % ncy; 
    index=cursX+ncx*cursY;

    if (curseur) afficheCurseur();
  }

  // ================================================
  void scrolup()
  {
    char[] sto = {' '};
    if (enroule) 
    {  
      sto = new char[ncx];
      for (int i=0; i<ncx; i++) { 
        sto[i]=contenuTab[i];
      }
    }
    for (int i=0; i<(ncy-1)*ncx; i++) 
    {
      contenuTab[i]=contenuTab[i+ncx];
    }
    if (enroule)
    { 
      for (int i=(ncy-1)*ncx; i<ncx*ncy; i++) 
      {
        contenuTab[i]=sto[i-(ncy-1)*ncx];
      }
    } else
    {
      for (int i=(ncy-1)*ncx; i<ncx*ncy; i++) 
      {
        contenuTab[i]=' ';
      };
    }
  }

  // ================================================
  void videLigne(int n)
  {
    for (int i=0; i<ncx; i++) 
    {
      contenuTab[i+n*ncx]=' ';
    }
  }
  // ================================================
  void clear()
  {
    for (int i=0; i<ncx*ncy; i++) contenuTab[i]=' '; // on rempli de blancs;
    dessineToutTexte();
    setPos(0, 0);
  }
  // ================================================
  void dessineBoite(boolean mode)
  {
    rectMode(CORNER);
    fill(colfond);
    stroke(colcadre);
    strokeWeight(1);
    rect(posx, posy, tailleBoiteX, tailleBoiteY); // on trace le fond
    if (mode) dessineToutTexte();
  }
  // ================================================
  void dessineToutTexte()
  {
    textSize(taille);
    fill(coltexte);
    for (int j=0; j<ncy; j++)
    {   
      for (int i=0; i<ncx; i++)
      {
        afficheCaractere(i, j, contenuTab[i+j*ncx]);
      }
    }
    setPos(0, 0);
  }
  // ================================================
  void dessineLigne(int n)
  {
    for (int i=0; i<ncx; i++) { 
      afficheCaractere(i, n, contenuTab[n*ncx+i]);
    }
  }
  // ================================================
  void graphClreoln()
  {
    int sto=cursX;
    for (int i=cursX; i<ncx; i++)
    {
      contenuTab[i+cursY*ncx]=' ';
    }
    dessineLigne(cursY);
    cursX=sto;
  }
  // ================================================
  void avanceCurseur()
  {
    index++;
    cursY=(index / ncx);
    cursX=index % ncx;
    if (cursX==0)
    {
      if (enroule)
      { 
        int cursYsto=cursY % ncy;
        videLigne(cursYsto);
        dessineLigne(cursYsto);
        cursX=0;
        cursY=cursYsto;
      } else
      {
        if (cursY>(ncy-1))
        {
          scrolup();
          dessineToutTexte();
          cursX=0;
          cursY=ncy-1;
        }
      }
    }
    setPos(cursX, cursY);
  }
  // ===============================================
  void afficheCaractere(int x, int y, char c)
  {
    if ((x>=0) & (x<ncx) & (y>=0) & (y<ncy))
    {
      textSize(taille);
      fill(colfond);
      rectMode(CORNER);
      noStroke();
      // on efface le caractere sous celui à afficher 
      rect(x*taille*0.9+2+posx, y*taille*1.5+2+posy, taille*0.9, taille*1.5);

      // on reconstitue le tableau de caractere
      contenuTab[x+y*ncx]=c;
      // on affiche le caractere
      fill(coltexte);
      text(c, x*taille*0.9+3+posx, -taille*0.25+(y+1)*taille*1.5+2+posy);
      setPos(x, y);
    }
  }
  // ===============================================
  void afficheTexteXY(int x, int y, String t)
  {
    for (int i=0; i<t.length(); i++)
    {
      afficheCaractere(x+i, y, t.charAt(i));
    }
  }
  // ================================================
  void graphprint(char c)
  {
    if (c=='\n')
    {
      if (enroule)
      {
        cursY=(cursY+1) % ncy;
        cursX=0;
        graphClreoln();
        cursX=0;
      } else
      {
        if (cursY==ncy-1) 
        {
          scrolup();
          dessineToutTexte();
          cursX=0;
          cursY=ncy-1;
        } else
        {
          cursY++;
          graphClreoln();
          cursX=0;
        }

        index=cursX+cursY*ncx;
      }
    } else 
    {
      afficheCaractere(cursX, cursY, c);
      avanceCurseur();
    }
  }
  // ********************************
  void graphprint(Char v)
  {
    graphprint(v.get());
  }
  // ================================================
  void graphprint(String c)
  {
    for (int i =0; i<c.length(); i++)
      graphprint(c.charAt(i));
  }
  // ================================================
  void graphprintln(char c)
  {
    graphprint (c);
    graphprint ('\n');
  }
  // ********************************
  void graphprintln(Char c)
  {
    graphprint(c.get());
  }
  // ================================================
  void graphprint(boolean c)
  {
    if (c) graphprint ("True");
    else graphprint ("False");
  }
  // ********************************
  void graphprint(Boolean c)
  {
    graphprint(c.get());
  }
  // ================================================
  void graphprintln(boolean c)
  {
    if (c) graphprint ("True");
    else graphprint ("False");

    graphprint ('\n');
  }
  // ********************************
  void graphprintln(Boolean c)
  {
    graphprintln(c.get());
  }
  // ================================================
  void graphprintln()
  {
    graphprint ('\n');
  }
  // ================================================
  void graphprintln(String c)
  {
    graphprint (c);
    graphprint ('\n');
  }
  // ================================================
  void graphprint(int i)
  {
    String reschaine="";
    boolean neg=false;
    if (i<0)
    {
      i=-i;
      neg=true;
    }
    if (i==0) {
      reschaine="0";
    } else
    {
      while (i>0)
      { 
        int  d=i % 10;
        reschaine=char(d+48)+reschaine;
        i=i/10;
      }
    }
    if (neg) reschaine="-"+reschaine;
    graphprint(reschaine);
  }
  // ********************************
  void graphprint(Int i)
  {
    graphprint(i.get());
  }
  // ================================================ 
  void graphprint(int i, int n)
  {
    String reschaine="";
    boolean neg=false;
    if (i<0)
    {
      i=-i;
      neg=true;
    }
    if (i==0) 
    {
      reschaine="0";
    } else
    {
      while (i>0)
      { 
        int  d=i % 10;
        reschaine=char(d+48)+reschaine;
        i=i/10;
      }
    }

    if (neg) reschaine="-"+reschaine;

    while ( reschaine.length()<n) reschaine=" "+reschaine;
    graphprint(reschaine);
  }
  // ********************************
  void graphprint(Int i, int n)
  {
    graphprint(i.get(), n);
  }
  // ================================================
  void graphprintln(int i)
  {
    graphprint (i);
    graphprint('\n');
  }
  // ********************************
  void graphprintln(Int i)
  {
    graphprintln(i.get());
  }
  // ================================================
  void graphprintln(int i, int n)
  {
    graphprint (i, n);
    graphprint('\n');
  }
  // ********************************
  void graphprintln(Int v, int n)
  {
    graphprintln(v.get(), n);
  }
  // ================================================
  void graphprint(float v)
  {
    if (v<0)
    {
      graphprint('-');
      v=abs(v);
    }
    int ve=int(v);
    int vd=int(round(((v-ve)*pow(10, 2))));
    graphprint(ve); 
    graphprint('.'); 
    graphprint(vd);
  }
  // ********************************
  void graphprint(Float v)
  {
    graphprintln(v.get());
  }
  // ================================================
  void graphprintln(float v)
  {
    graphprint(v);
    graphprint('\n');
  }
  // ********************************
  void graphprintln(Float v)
  {
    graphprintln(v.get());
  }
  // ================================================
  void graphprint(float v, int ndig, int ndec)
  {
    boolean neg = false;
    ndec=abs(ndec);
    neg=v<0;
    v=abs(v);
    int ve=int(v);
    int vd=0;
    if (ndec==0)
    {
      if ((v-ve)>=0.5) ve++;
    } else
    {
      vd=int(round(((v-ve)*pow(10, ndec))));
    }
    if ((ve==0) & neg)
    {
      String vt="-0";
      while (vt.length()<ndig-ndec-1) vt=" "+vt;
      graphprint(vt);
    } else  
    {
      if (neg)
      {
        ve=-ve;
      }
      graphprint(ve, ndig-ndec-1);
    }
    graphprint('.'); 
    if (vd!=0) graphprint(vd, ndec);
  }
  // ********************************
  void graphprint(Float v, int ndig, int ndec)
  {
    graphprint(v.get(), ndig, ndec);
  }
  // ================================================
  void graphprintln(float v, int ndig, int ndec)
  {
    graphprint(v, ndig, ndec);
    graphprint('\n');
  }
  // ********************************
  void graphprintln(Float v, int ndig, int ndec)
  {
    graphprintln(v.get(), ndig, ndec);
  }
  // ================================================

  void graphprint(float v, int ndec)
  {
    boolean neg = false;
    ndec=abs(ndec);
    neg=v<0;
    v=abs(v);
    int ve=int(v);
    int vd=0;
    if (ndec==0)
    {
      if ((v-ve)>=0.5) ve++;
    } else
    {
      vd=int(round(((v-ve)*pow(10, ndec))));
    }
    if ((ve==0) & neg)
    {
      String vt="-0";
      graphprint(vt);
    } else  
    {
      if (neg)
      {
        ve=-ve;
      }
      graphprint(ve);
    }
    graphprint('.'); 
    if (vd!=0) graphprint(vd, ndec);
  }
  // ********************************
  void graphprint(Float v, int ndec)
  {
    graphprint(v.get(), ndec);
  }
  // ================================================
  void graphprintln(float v, int ndec)
  {
    graphprint(v, ndec);
    graphprint('\n');
  }
  // ************
  void graphprintln(Float v, int ndec)
  {
    graphprintln(v.get(), ndec);
  }
  // ================================================
  void graphprintArray(int[] d)
  {
    for (int i=0; i<d.length; i++)
    { 
      graphprint('['); 
      graphprint(i);
      graphprint("] "); 
      graphprintln(d[i]);
    }
  }
  // ================================================
  void graphprintArray(String[] d)
  {
    for (int i=0; i<d.length; i++)
    { 
      graphprint('['); 
      graphprint(i);
      graphprint(']'); 
      graphprintln('"'+d[i]+'"');
    }
  }
  // ================================================
  void graphprintArray(String[] d, char prem )
  {
    for (int i=0; i<d.length; i++)
    { 
      graphprint('['); 
      graphprint(prem); 
      prem=char(int(prem)+1);
      graphprint(":]"); 
      graphprintln('"'+d[i]+'"');
    }
  }
};
